const crypto = require('crypto');

function generateSimulatedHash(difficulty) {
    let data;

    if (difficulty === 'gentil') {
        data = crypto.randomBytes(1).toString('hex'); // Mode gentil (faible complexité)
    } else if (difficulty === 'normal') {
        data = crypto.randomBytes(3).toString('hex'); // Mode normal (moyenne complexité)
    } else if (difficulty === 'agressif') {
        data = crypto.randomBytes(5).toString('hex'); // Mode agressif (haute complexité)
    }

    console.log(`Data généré: ${data}`);
    const hash = crypto.createHash('md5').update(data).digest('hex');
    return hash;
}

function sendHashToSlave(hash, client, start, end) {
    client.send(`search ${hash} ${start} ${end}`);
}

const createNewSlave = () => {
    const command = 'sudo docker run -ti --network host --rm servuc/hash_extractor:latest ./hash_extractor s ws://127.0.0.1:3000';

    exec(command, (error, stdout, stderr) => {
        if (error) {
            console.error(`Erreur lors de la création du nouvel esclave: ${error.message}`);
            return;
        }

        if (stderr) {
            console.error(`Erreur lors de la création du nouvel esclave: ${stderr}`);
            return;
        }

        console.log(`Nouvel esclave créé avec succès: ${stdout}`);
    });
};

module.exports = {
    generateSimulatedHash,
    sendHashToSlave,
    createNewSlave
};